//class MyThread extends Threads...
//////////////////////////////////////////////////////////////////////////
class Threads extends Thread {
  Complex zNeu,zAlt,C,c,z0,D,dZNeu, dZAlt;
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int tN;
  double massFuerUnendlich;
  double wh;
  protected boolean running = false;
  int zaehlen;
  double aQMax =0;
  int farbIndex =0;
  double aQ,laenge;
  double x0 ;
  double y0 ;
  boolean julia;
  boolean dem;
  double epsilon ;

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, int nummer, double X0, double Y0, boolean Julia,double e, boolean DEM) {
    // benötigte Parameter
    epsilon =e;
    dem = DEM;
    julia = Julia;
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    x0 = X0; y0 = Y0;
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
   
    C = new Complex(X0,Y0);
    pg = createGraphics(width,height/anzahlThreads);
    zaehlen =0;
    int[][] Rand = new int[width][height/anzahlThreads];
    for (int j =0; j < height/anzahlThreads; j++) {  
      for (int i = 0; i < width; i++) {
         Rand[i][j]=0;
      }
    }
  }
////////////////////////////////////////////////////////////////////  
  public int gibNummer(){   
    return tN;   
  }

 //////////////////////////////////////////////////////////////
public void run() {
    
    tN =this.gibNummer(); //println(tN);
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            c = new Complex(x,y);
           
            if(julia){
             
               if(DEM) pg.pixels[i+j*pg.width] = juliaDEM(c,dx,dy);                 
               else pg.pixels[i+j*pg.width] = juliaIteration(c,dx,dy);
                       
            }else{
               int n = mandelbrotIteration(c);          
               pg.pixels[i+j*pg.width] = colorize(n);
            }      
            x += dx; //if(tN==0 && y==0) println(x);
          }
          y += dy;
        }      
        
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
   
  }
  /////////////////////////////////////////////////////////////////////
color juliaDEM(Complex Z0, double Dx, double Dy) {
    julia = true;
    int charakter1,charakter2,charakter3, charakter4;
    color rueckgabe ;
    double laengeZ=0;
    double laengeDZ=0;
    int n = 0;
    double D = 0; //estimated distance
    dZNeu = new Complex(0,0);
    dZAlt = new Complex(1,0);
    zAlt = new Complex(Z0.getRealPart(),Z0.getImaginaryPart());;
    while (n < maxiterations) {
        zNeu = zAlt.multiply(zAlt);
        zNeu = zNeu.addC(C);
        laengeZ =zNeu.getLength();
        dZNeu = zAlt.multiply(dZAlt);
        dZNeu = dZNeu.multiply(2);
        laengeDZ = dZNeu.getLength();
        D = laengeZ*Math.log(laengeZ)/laengeDZ;
        if (laengeZ > massFuerUnendlich) {
          break;  // Bail
        } 
        zAlt = zNeu;
        dZAlt = dZNeu;
        n++;
    }
    if(D < epsilon) charakter1 = 0; else charakter1 =1;
    
    laengeZ=0;
    laengeDZ=0;
    n = 0;
    D = 0;
    n = 0;
    dZNeu = new Complex(0,0);
    dZAlt = new Complex(1,0);
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart());
    while (n < maxiterations) {
        zNeu = zAlt.multiply(zAlt);
        zNeu = zNeu.addC(C);
        laengeZ =zNeu.getLength();
        dZNeu = zAlt.multiply(dZAlt);
        dZNeu = dZNeu.multiply(2);
        laengeDZ = dZNeu.getLength();
        D = laengeZ*Math.log(laengeZ)/laengeDZ;
        if (laenge > massFuerUnendlich) {
          break;  // Bail
        } 
        zAlt = zNeu;
        dZAlt = dZNeu;
        n++;
    }
    if(D < epsilon)  charakter2= 0;  else charakter2 =1;
    
    laengeZ=0;
    laengeDZ=0;
    n = 0;
    D = 0;
    n = 0;
    dZNeu = new Complex(0,0);
    dZAlt = new Complex(1,0);
    zAlt = new Complex(Z0.getRealPart(),Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
         zNeu = zAlt.multiply(zAlt);
        zNeu = zNeu.addC(C);
        laengeZ =zNeu.getLength();
        dZNeu = zAlt.multiply(dZAlt);
        dZNeu = dZNeu.multiply(2);
        laengeDZ = dZNeu.getLength();
        D = laengeZ*Math.log(laengeZ)/laengeDZ;
        if (laenge > massFuerUnendlich) {
          break;  // Bail
        } 
        zAlt = zNeu;
        dZAlt = dZNeu;
        n++;
    }
    if(D < epsilon)  charakter3 = 0; else charakter3 =1;
    
    laengeZ=0;
    laengeDZ=0;
    n = 0;
    D = 0;
    n = 0;
    dZNeu = new Complex(0,0);
    dZAlt = new Complex(1,0);
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
        zNeu = zAlt.multiply(zAlt);
        zNeu = zNeu.addC(C);
        laengeZ =zNeu.getLength();
        dZNeu = zAlt.multiply(dZAlt);
        dZNeu = dZNeu.multiply(2);
        laengeDZ = dZNeu.getLength();
        D = laengeZ*Math.log(laengeZ)/laengeDZ;
        if (laenge > massFuerUnendlich) {
          break;  // Bail
        } 
        zAlt = zNeu;
        dZAlt = dZNeu;
        n++;
    }
    if(D < epsilon)  charakter4 = 0;  else charakter4 =1;
    
    
    int charSum = charakter1 + charakter2 + charakter3 + charakter4;
    if(charSum == 1 || charSum == 2  ) rueckgabe = color(255);//Pixel weiß: ein, zwei Eckpunkte im Chaos
       else rueckgabe = color(0);                            // d.h. drei oder zwei Eckpunkte im Konvergenzbereich
       
   // if(rueckgabe ==1) { kontrolle++; println(kontrolle);}
    return rueckgabe;
    
 
 }
/////////////////////////////////////////////////////////////////////
int mandelbrotIteration(Complex C) {
  julia =false;
  int n = 0;
  zAlt = C;
  while (n < maxiterations) {
    zNeu =zAlt.multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge =zNeu.getLength();
    aQ = 1000*laenge;
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
    zAlt = zNeu;
    n++;
  }

  return n;
 }
/////////////////////////////////////////////////////////////////////
color juliaIteration(Complex Z0, double Dx, double Dy) {
    julia = true;
    int charakter1,charakter2,charakter3, charakter4;
    int rueckgabe = 0;
    int n = 0;
    zAlt = Z0;
    while (n < maxiterations) {
      zNeu = zAlt.multiply(zAlt);
      zNeu = zNeu.addC(C);
      laenge =zNeu.getLength();
      if (laenge > massFuerUnendlich) {
        break;  // Bail
    } 
    zAlt = zNeu;
     n++;
    }
    if(n== maxiterations) charakter1 = 0; 
      else charakter1 =1;
    
    
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart());
    while (n < maxiterations) {
      zNeu = zAlt.multiply(zAlt);
      zNeu = zNeu.addC(C);
      laenge =zNeu.getLength();
      if (laenge > massFuerUnendlich) {
        break;  // Bail
    } 
    zAlt = zNeu;
     n++;
    }
    if(n== maxiterations) charakter2 = 0; 
      else charakter2 =1;
    
    
    n = 0;
    zAlt = new Complex(Z0.getRealPart(),Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
      zNeu = zAlt.multiply(zAlt);
      zNeu = zNeu.addC(C);
      laenge =zNeu.getLength();
      if (laenge > massFuerUnendlich) {
        break;  // Bail
    } 
    zAlt = zNeu;
     n++;
    }
    if(n== maxiterations) charakter3 = 0; 
      else charakter3 =1;
    
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
      zNeu = zAlt.multiply(zAlt);
      zNeu = zNeu.addC(C);
      laenge =zNeu.getLength();
      if (laenge > massFuerUnendlich) {
        break;  // Bail
    } 
    zAlt = zNeu;
     n++;
    }
    if(n== maxiterations) charakter4 = 0; 
      else charakter4 =1;
      
    int charSum = charakter1 + charakter2 + charakter3 + charakter4;
    if(charSum == 1 || charSum == 2) rueckgabe = color(255,255,0);//Pixel eiß: ein oder zwei Eckpunkte im Konvergenzbereich
       else rueckgabe = color(0);
      
    return rueckgabe;
    
 }


////////////////////////////////////////////////////////////////////
color colorize(int n) {
  colorMode(RGB);
  if (n == maxiterations){
   if(julia) farbe = color(0);
      else farbe = color(0,0,100);
     return  farbe;
  }else{   
    farbe = color(200);    
    return farbe; 
  }
 }
}
